<script lang="ts">
  import Paper from "@smui/paper";
  import Fab from "@smui/fab";
  import { Icon } from "@smui/common";
  import { Input } from "@smui/textfield";

  export let value: string;
  export let state: string;
  export let doSearch: () => void;
  export let stopSearch: () => void;

  function handleKeyDown(event: CustomEvent | KeyboardEvent) {
    event = event as KeyboardEvent;
    if (event.key === "Enter") {
      doSearch();
    }
  }
</script>

<div class="flex justify-center items-center">
  <Paper class="flex items-center grow max-w-2xl mx-3 px-3 h-12" elevation={6}>
    <Icon class="material-icons inline-block mx-3">search</Icon>
    <Input
      bind:value
      on:keydown={handleKeyDown}
      placeholder="Searchterm"
      disabled={state === "loading"}
      class="grow inline-block mx-3 placeholder:italic placeholder:text-slate-400 placeholder:opacity-60"
      data-test="search-bar"
    />
  </Paper>
  <Fab
    on:click={state === "loading" ? stopSearch : doSearch}
    disabled={value === ""}
    color="primary"
    mini
    class={state === "loading" ? "bg-red-600" : ""}
  >
    {#if state === "loading"}
      <Icon data-test="search-loading" class="material-icons">close</Icon>
    {:else}
      <Icon data-test="search-finished" class="material-icons"
        >arrow_forward</Icon
      >
    {/if}
  </Fab>
</div>
<div class="flex justify-center items-center mt-2">
  <p class="italic text-slate-400">
    Hint: Append "zenodo in:readme" or "doi in:readme" for better results
  </p>
</div>
